#include <cmath>
#include <string>

#include "include/coord.h"
#include "include/mob.h"

Mob::Mob(char symbol, Coord location)
	: Mob(symbol, location, name, 5, 0, 10, 1)
	  {}

Mob::Mob(char symbol, Coord location, std::string name, int armor, int exp, int mobHP, int level)
	: armor(armor),
	  currentHP(mobHP),
	  exp(exp),
	  level(level),
	  location(location),
	  maxHP(mobHP),
	  name(name),
	  symbol(symbol) {}

int Mob::diceSum(int rolls, int faces) {
	int sum = 0;

	for (int roll = 0 ; roll < rolls ; roll++)
		sum += 1 + (rand() % faces);

	return sum;
}

int Mob::getArmor() {
	return armor;
}

int Mob::getExperience() {
	return exp;
}

int Mob::getHP() {
	return currentHP;
}

int Mob::getMaxHP() {
	return maxHP;
}

int Mob::getLevel() {
	return level;
}

Coord& Mob::getLocation() {
	return location;
}

std::string Mob::getName() {
	return name;
}

char Mob::getSymbol() {
	return symbol;
}

void Mob::hit(int damage) {
	// TODO
	
	int deltaHP = std::max(1, damage - this->armor);
	this->currentHP -= deltaHP;
}

void Mob::moveLocation(Coord location) {
	this->location += location;
}

void Mob::setCurrentHP(int currentHP) {
	this->currentHP = currentHP;
}

void Mob::setLocation(Coord location) {
	this->location = location;
}

void Mob::setMaxHP(int maxHP) {
	this->maxHP = maxHP;
}

Mob::~Mob() {}
